// SPDX-License-Identifier: Apache-2.0
// Copyright Authors of Cilium

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v2 "github.com/cilium/cilium/pkg/k8s/apis/cilium.io/v2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeCiliumClusterwideEnvoyConfigs implements CiliumClusterwideEnvoyConfigInterface
type FakeCiliumClusterwideEnvoyConfigs struct {
	Fake *FakeCiliumV2
}

var ciliumclusterwideenvoyconfigsResource = v2.SchemeGroupVersion.WithResource("ciliumclusterwideenvoyconfigs")

var ciliumclusterwideenvoyconfigsKind = v2.SchemeGroupVersion.WithKind("CiliumClusterwideEnvoyConfig")

// Get takes name of the ciliumClusterwideEnvoyConfig, and returns the corresponding ciliumClusterwideEnvoyConfig object, and an error if there is any.
func (c *FakeCiliumClusterwideEnvoyConfigs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v2.CiliumClusterwideEnvoyConfig, err error) {
	emptyResult := &v2.CiliumClusterwideEnvoyConfig{}
	obj, err := c.Fake.
		Invokes(testing.NewRootGetActionWithOptions(ciliumclusterwideenvoyconfigsResource, name, options), emptyResult)
	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v2.CiliumClusterwideEnvoyConfig), err
}

// List takes label and field selectors, and returns the list of CiliumClusterwideEnvoyConfigs that match those selectors.
func (c *FakeCiliumClusterwideEnvoyConfigs) List(ctx context.Context, opts v1.ListOptions) (result *v2.CiliumClusterwideEnvoyConfigList, err error) {
	emptyResult := &v2.CiliumClusterwideEnvoyConfigList{}
	obj, err := c.Fake.
		Invokes(testing.NewRootListActionWithOptions(ciliumclusterwideenvoyconfigsResource, ciliumclusterwideenvoyconfigsKind, opts), emptyResult)
	if obj == nil {
		return emptyResult, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v2.CiliumClusterwideEnvoyConfigList{ListMeta: obj.(*v2.CiliumClusterwideEnvoyConfigList).ListMeta}
	for _, item := range obj.(*v2.CiliumClusterwideEnvoyConfigList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested ciliumClusterwideEnvoyConfigs.
func (c *FakeCiliumClusterwideEnvoyConfigs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchActionWithOptions(ciliumclusterwideenvoyconfigsResource, opts))
}

// Create takes the representation of a ciliumClusterwideEnvoyConfig and creates it.  Returns the server's representation of the ciliumClusterwideEnvoyConfig, and an error, if there is any.
func (c *FakeCiliumClusterwideEnvoyConfigs) Create(ctx context.Context, ciliumClusterwideEnvoyConfig *v2.CiliumClusterwideEnvoyConfig, opts v1.CreateOptions) (result *v2.CiliumClusterwideEnvoyConfig, err error) {
	emptyResult := &v2.CiliumClusterwideEnvoyConfig{}
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateActionWithOptions(ciliumclusterwideenvoyconfigsResource, ciliumClusterwideEnvoyConfig, opts), emptyResult)
	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v2.CiliumClusterwideEnvoyConfig), err
}

// Update takes the representation of a ciliumClusterwideEnvoyConfig and updates it. Returns the server's representation of the ciliumClusterwideEnvoyConfig, and an error, if there is any.
func (c *FakeCiliumClusterwideEnvoyConfigs) Update(ctx context.Context, ciliumClusterwideEnvoyConfig *v2.CiliumClusterwideEnvoyConfig, opts v1.UpdateOptions) (result *v2.CiliumClusterwideEnvoyConfig, err error) {
	emptyResult := &v2.CiliumClusterwideEnvoyConfig{}
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateActionWithOptions(ciliumclusterwideenvoyconfigsResource, ciliumClusterwideEnvoyConfig, opts), emptyResult)
	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v2.CiliumClusterwideEnvoyConfig), err
}

// Delete takes name of the ciliumClusterwideEnvoyConfig and deletes it. Returns an error if one occurs.
func (c *FakeCiliumClusterwideEnvoyConfigs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(ciliumclusterwideenvoyconfigsResource, name, opts), &v2.CiliumClusterwideEnvoyConfig{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeCiliumClusterwideEnvoyConfigs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionActionWithOptions(ciliumclusterwideenvoyconfigsResource, opts, listOpts)

	_, err := c.Fake.Invokes(action, &v2.CiliumClusterwideEnvoyConfigList{})
	return err
}

// Patch applies the patch and returns the patched ciliumClusterwideEnvoyConfig.
func (c *FakeCiliumClusterwideEnvoyConfigs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v2.CiliumClusterwideEnvoyConfig, err error) {
	emptyResult := &v2.CiliumClusterwideEnvoyConfig{}
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceActionWithOptions(ciliumclusterwideenvoyconfigsResource, name, pt, data, opts, subresources...), emptyResult)
	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v2.CiliumClusterwideEnvoyConfig), err
}
