// SPDX-License-Identifier: Apache-2.0
// Copyright Authors of Cilium

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v2 "github.com/cilium/cilium/pkg/k8s/apis/cilium.io/v2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeCiliumEgressGatewayPolicies implements CiliumEgressGatewayPolicyInterface
type FakeCiliumEgressGatewayPolicies struct {
	Fake *FakeCiliumV2
}

var ciliumegressgatewaypoliciesResource = v2.SchemeGroupVersion.WithResource("ciliumegressgatewaypolicies")

var ciliumegressgatewaypoliciesKind = v2.SchemeGroupVersion.WithKind("CiliumEgressGatewayPolicy")

// Get takes name of the ciliumEgressGatewayPolicy, and returns the corresponding ciliumEgressGatewayPolicy object, and an error if there is any.
func (c *FakeCiliumEgressGatewayPolicies) Get(ctx context.Context, name string, options v1.GetOptions) (result *v2.CiliumEgressGatewayPolicy, err error) {
	emptyResult := &v2.CiliumEgressGatewayPolicy{}
	obj, err := c.Fake.
		Invokes(testing.NewRootGetActionWithOptions(ciliumegressgatewaypoliciesResource, name, options), emptyResult)
	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v2.CiliumEgressGatewayPolicy), err
}

// List takes label and field selectors, and returns the list of CiliumEgressGatewayPolicies that match those selectors.
func (c *FakeCiliumEgressGatewayPolicies) List(ctx context.Context, opts v1.ListOptions) (result *v2.CiliumEgressGatewayPolicyList, err error) {
	emptyResult := &v2.CiliumEgressGatewayPolicyList{}
	obj, err := c.Fake.
		Invokes(testing.NewRootListActionWithOptions(ciliumegressgatewaypoliciesResource, ciliumegressgatewaypoliciesKind, opts), emptyResult)
	if obj == nil {
		return emptyResult, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v2.CiliumEgressGatewayPolicyList{ListMeta: obj.(*v2.CiliumEgressGatewayPolicyList).ListMeta}
	for _, item := range obj.(*v2.CiliumEgressGatewayPolicyList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested ciliumEgressGatewayPolicies.
func (c *FakeCiliumEgressGatewayPolicies) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchActionWithOptions(ciliumegressgatewaypoliciesResource, opts))
}

// Create takes the representation of a ciliumEgressGatewayPolicy and creates it.  Returns the server's representation of the ciliumEgressGatewayPolicy, and an error, if there is any.
func (c *FakeCiliumEgressGatewayPolicies) Create(ctx context.Context, ciliumEgressGatewayPolicy *v2.CiliumEgressGatewayPolicy, opts v1.CreateOptions) (result *v2.CiliumEgressGatewayPolicy, err error) {
	emptyResult := &v2.CiliumEgressGatewayPolicy{}
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateActionWithOptions(ciliumegressgatewaypoliciesResource, ciliumEgressGatewayPolicy, opts), emptyResult)
	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v2.CiliumEgressGatewayPolicy), err
}

// Update takes the representation of a ciliumEgressGatewayPolicy and updates it. Returns the server's representation of the ciliumEgressGatewayPolicy, and an error, if there is any.
func (c *FakeCiliumEgressGatewayPolicies) Update(ctx context.Context, ciliumEgressGatewayPolicy *v2.CiliumEgressGatewayPolicy, opts v1.UpdateOptions) (result *v2.CiliumEgressGatewayPolicy, err error) {
	emptyResult := &v2.CiliumEgressGatewayPolicy{}
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateActionWithOptions(ciliumegressgatewaypoliciesResource, ciliumEgressGatewayPolicy, opts), emptyResult)
	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v2.CiliumEgressGatewayPolicy), err
}

// Delete takes name of the ciliumEgressGatewayPolicy and deletes it. Returns an error if one occurs.
func (c *FakeCiliumEgressGatewayPolicies) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(ciliumegressgatewaypoliciesResource, name, opts), &v2.CiliumEgressGatewayPolicy{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeCiliumEgressGatewayPolicies) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionActionWithOptions(ciliumegressgatewaypoliciesResource, opts, listOpts)

	_, err := c.Fake.Invokes(action, &v2.CiliumEgressGatewayPolicyList{})
	return err
}

// Patch applies the patch and returns the patched ciliumEgressGatewayPolicy.
func (c *FakeCiliumEgressGatewayPolicies) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v2.CiliumEgressGatewayPolicy, err error) {
	emptyResult := &v2.CiliumEgressGatewayPolicy{}
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceActionWithOptions(ciliumegressgatewaypoliciesResource, name, pt, data, opts, subresources...), emptyResult)
	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v2.CiliumEgressGatewayPolicy), err
}
